---
title: Bounce off the walls
slug: Games/Tutorials/2D_Breakout_game_pure_JavaScript/Bounce_off_the_walls
tags:
  - Animation
  - Beginner
  - Canvas
  - Example
  - Games
  - Graphics
  - Tutorial
  - collision
  - detection
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Move_the_ball", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Paddle_and_keyboard_controls")}}</p>

<div class="summary">
<p>This is the <strong>3rd step</strong> out of 10 of the <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch">Gamedev Canvas tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Canvas-workshop/blob/gh-pages/lesson03.html">Gamedev-Canvas-workshop/lesson3.html</a>.</p>
</div>

<p><span class="seoSummary">It is nice to see our ball moving, but it quickly disappears from the screen, limiting the fun we can have with it! To overcome that we will implement some very simple collision detection (which will be explained <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch/Collision_detection">later</a> in more detail) to make the ball bounce off the four edges of the Canvas.</span></p>

<h2 id="Simple_collision_detection">Simple collision detection</h2>

<p>To detect the collision we will check whether the ball is touching (colliding with) the wall, and if so, we will change the direction of its movement accordingly.</p>

<p>To make the calculations easier let's define a variable called <code>ballRadius</code> that will hold the radius of the drawn circle and be used for calculations. Add this to your code, somewhere below the existing variable declarations:</p>

<pre class="brush: js notranslate">var ballRadius = 10;</pre>

<p>Now update the line that draws the ball inside the <code>drawBall()</code> function to this:</p>

<pre class="brush: js notranslate">ctx.arc(x, y, ballRadius, 0, Math.PI*2);</pre>

<h3 id="Bouncing_off_the_top_and_bottom">Bouncing off the top and bottom</h3>

<p>There are four walls to bounce the ball off — let's focus on the top one first. We need to check, on every frame, whether the ball is touching the top edge of the Canvas — if yes, we'll reverse the ball movement so it will start to move in the opposite direction and stay within the visible boundaries. Remembering that the coordinate system starts from the top left, we can come up with something like this:</p>

<pre class="brush: js notranslate">if(y + dy &lt; 0) {
    dy = -dy;
}</pre>

<p>If the <code>y</code> value of the ball position is lower than zero, change the direction of the movement on the <code>y</code> axis by setting it equal to itself, reversed. If the ball was moving upwards with a speed of 2 pixels per frame, now it will be moving "up" with a speed of -2 pixels, which actually equals to moving down at a speed of 2 pixels per frame.</p>

<p>The code above would deal with the ball bouncing off the top edge, so now let's think about the bottom edge:</p>

<pre class="brush: js notranslate">if(y + dy &gt; canvas.height) {
    dy = -dy;
}</pre>

<p>If the ball's <code>y</code> position is greater than the height of the Canvas (remember that we count the <code>y</code> values from the top left, so the top edge starts at 0 and the bottom edge is at 320 pixels, the Canvas' height), then bounce it off the bottom edge by reversing the <code>y</code> axis movement as before.</p>

<p>We could merge those two statements into one to save on code verbosity:</p>

<pre class="brush: js notranslate">if(y + dy &gt; canvas.height || y + dy &lt; 0) {
    dy = -dy;
}</pre>

<p>If either of the two statements is <code>true</code>, reverse the movement of the ball.</p>

<h3 id="Bouncing_off_the_left_and_right">Bouncing off the left and right</h3>

<p>We have the top and bottom edge covered, so let's think about the left and right ones. It is very similar actually, all you have to do is to repeat the statements for <code>x</code> instead of <code>y</code>:</p>

<pre class="brush: js notranslate">if(x + dx &gt; canvas.width || x + dx &lt; 0) {
    dx = -dx;
}

if(y + dy &gt; canvas.height || y + dy &lt; 0) {
    dy = -dy;
}</pre>

<p>At this point you should insert the above code block into the draw() function, just before the closing curly brace.</p>

<h3 id="The_ball_keeps_disappearing_into_the_wall!">The ball keeps disappearing into the wall!</h3>

<p>Test your code at this point, and you will be impressed — now we have a ball that bounced off all four edges of the canvas! We have another problem however — when the ball hits each wall it sinks into it slightly before changing direction:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10432/ball-in-wall.png" style="display: block; height: 320px; margin: 0px auto; width: 480px;"></p>

<p>This is because we're calculating the collision point of the wall and the center of the ball, while we should be doing it for its circumference. The ball should bounce right after if touches the wall, not when it's already halfway in the wall, so let's adjust our statements a bit to include that. Update the last code you added to this:</p>

<pre class="brush: js notranslate">if(x + dx &gt; canvas.width-ballRadius || x + dx &lt; ballRadius) {
    dx = -dx;
}
if(y + dy &gt; canvas.height-ballRadius || y + dy &lt; ballRadius) {
    dy = -dy;
}</pre>

<p>When the distance between the center of the ball and the edge of the wall is exactly the same as the radius of the ball, it will change the movement direction. Subtracting the radius from one edge's width and adding it onto the other gives us the impression of the proper collision detection — the ball bounces off the walls as it should do.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>Lets again check the finished code for this part against what you've got, and have a play:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/redj37dc/","","395")}}</p>

<div class="note">
<p><strong>Exercise</strong>: try changing the color of the ball to a random colour every time it hits the wall.</p>
</div>

<h2 id="Next_steps">Next steps</h2>

<p>We've now got to the stage where our ball is both moving and staying on the game board. In the fourth chapter we'll look at implementing a controllable paddle — see <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch/Paddle_and_keyboard_controls">Paddle and keyboard controls</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Move_the_ball", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Paddle_and_keyboard_controls")}}</p>
